<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml" xml:lang="en" lang="en">
<head><meta http-equiv="content-type" content="text/html; charset=UTF-8" />
<title>TemplateUtils xref</title>
<link type="text/css" rel="stylesheet" href="../../../../../../../stylesheet.css" />
</head>
<body>
<div id="overview"><a href="../../../../../../../../apidocs/org/eclipse/papyrus/designer/components/transformation/templates/TemplateUtils.html">View Javadoc</a></div><pre>
<a class="jxr_linenumber" name="L1" href="#L1">1</a>   <em class="jxr_javadoccomment">/*****************************************************************************</em>
<a class="jxr_linenumber" name="L2" href="#L2">2</a>   <em class="jxr_javadoccomment"> * Copyright (c) 2013 CEA LIST.</em>
<a class="jxr_linenumber" name="L3" href="#L3">3</a>   <em class="jxr_javadoccomment"> *</em>
<a class="jxr_linenumber" name="L4" href="#L4">4</a>   <em class="jxr_javadoccomment"> *</em>
<a class="jxr_linenumber" name="L5" href="#L5">5</a>   <em class="jxr_javadoccomment"> * All rights reserved. This program and the accompanying materials</em>
<a class="jxr_linenumber" name="L6" href="#L6">6</a>   <em class="jxr_javadoccomment"> * are made available under the terms of the Eclipse Public License v1.0</em>
<a class="jxr_linenumber" name="L7" href="#L7">7</a>   <em class="jxr_javadoccomment"> * which accompanies this distribution, and is available at</em>
<a class="jxr_linenumber" name="L8" href="#L8">8</a>   <em class="jxr_javadoccomment"> * <a href="http://www.eclipse.org/legal/epl-v10.htm" target="alexandria_uri">http://www.eclipse.org/legal/epl-v10.htm</a>l</em>
<a class="jxr_linenumber" name="L9" href="#L9">9</a>   <em class="jxr_javadoccomment"> *</em>
<a class="jxr_linenumber" name="L10" href="#L10">10</a>  <em class="jxr_javadoccomment"> * Contributors:</em>
<a class="jxr_linenumber" name="L11" href="#L11">11</a>  <em class="jxr_javadoccomment"> *  Ansgar Radermacher  ansgar.radermacher@cea.fr</em>
<a class="jxr_linenumber" name="L12" href="#L12">12</a>  <em class="jxr_javadoccomment"> *</em>
<a class="jxr_linenumber" name="L13" href="#L13">13</a>  <em class="jxr_javadoccomment"> *****************************************************************************/</em>
<a class="jxr_linenumber" name="L14" href="#L14">14</a>  
<a class="jxr_linenumber" name="L15" href="#L15">15</a>  <strong class="jxr_keyword">package</strong> org.eclipse.papyrus.designer.components.transformation.templates;
<a class="jxr_linenumber" name="L16" href="#L16">16</a>  
<a class="jxr_linenumber" name="L17" href="#L17">17</a>  <strong class="jxr_keyword">import</strong> java.util.Iterator;
<a class="jxr_linenumber" name="L18" href="#L18">18</a>  
<a class="jxr_linenumber" name="L19" href="#L19">19</a>  <strong class="jxr_keyword">import</strong> org.eclipse.emf.common.util.BasicEList;
<a class="jxr_linenumber" name="L20" href="#L20">20</a>  <strong class="jxr_keyword">import</strong> org.eclipse.emf.common.util.EList;
<a class="jxr_linenumber" name="L21" href="#L21">21</a>  <strong class="jxr_keyword">import</strong> org.eclipse.papyrus.designer.components.transformation.Activator;
<a class="jxr_linenumber" name="L22" href="#L22">22</a>  <strong class="jxr_keyword">import</strong> org.eclipse.papyrus.designer.components.transformation.Messages;
<a class="jxr_linenumber" name="L23" href="#L23">23</a>  <strong class="jxr_keyword">import</strong> org.eclipse.papyrus.designer.components.transformation.PortUtils;
<a class="jxr_linenumber" name="L24" href="#L24">24</a>  <strong class="jxr_keyword">import</strong> org.eclipse.papyrus.designer.languages.common.base.ElementUtils;
<a class="jxr_linenumber" name="L25" href="#L25">25</a>  <strong class="jxr_keyword">import</strong> org.eclipse.papyrus.designer.transformation.base.utils.CreationUtils;
<a class="jxr_linenumber" name="L26" href="#L26">26</a>  <strong class="jxr_keyword">import</strong> org.eclipse.papyrus.designer.transformation.base.utils.TransformationException;
<a class="jxr_linenumber" name="L27" href="#L27">27</a>  <strong class="jxr_keyword">import</strong> org.eclipse.papyrus.designer.transformation.core.transformations.LazyCopier;
<a class="jxr_linenumber" name="L28" href="#L28">28</a>  <strong class="jxr_keyword">import</strong> org.eclipse.papyrus.uml.tools.utils.ConnectorUtil;
<a class="jxr_linenumber" name="L29" href="#L29">29</a>  <strong class="jxr_keyword">import</strong> org.eclipse.uml2.uml.Classifier;
<a class="jxr_linenumber" name="L30" href="#L30">30</a>  <strong class="jxr_keyword">import</strong> org.eclipse.uml2.uml.ConnectableElement;
<a class="jxr_linenumber" name="L31" href="#L31">31</a>  <strong class="jxr_keyword">import</strong> org.eclipse.uml2.uml.Connector;
<a class="jxr_linenumber" name="L32" href="#L32">32</a>  <strong class="jxr_keyword">import</strong> org.eclipse.uml2.uml.ConnectorEnd;
<a class="jxr_linenumber" name="L33" href="#L33">33</a>  <strong class="jxr_keyword">import</strong> org.eclipse.uml2.uml.Element;
<a class="jxr_linenumber" name="L34" href="#L34">34</a>  <strong class="jxr_keyword">import</strong> org.eclipse.uml2.uml.EncapsulatedClassifier;
<a class="jxr_linenumber" name="L35" href="#L35">35</a>  <strong class="jxr_keyword">import</strong> org.eclipse.uml2.uml.NamedElement;
<a class="jxr_linenumber" name="L36" href="#L36">36</a>  <strong class="jxr_keyword">import</strong> org.eclipse.uml2.uml.Namespace;
<a class="jxr_linenumber" name="L37" href="#L37">37</a>  <strong class="jxr_keyword">import</strong> org.eclipse.uml2.uml.Package;
<a class="jxr_linenumber" name="L38" href="#L38">38</a>  <strong class="jxr_keyword">import</strong> org.eclipse.uml2.uml.PackageMerge;
<a class="jxr_linenumber" name="L39" href="#L39">39</a>  <strong class="jxr_keyword">import</strong> org.eclipse.uml2.uml.ParameterableElement;
<a class="jxr_linenumber" name="L40" href="#L40">40</a>  <strong class="jxr_keyword">import</strong> org.eclipse.uml2.uml.Port;
<a class="jxr_linenumber" name="L41" href="#L41">41</a>  <strong class="jxr_keyword">import</strong> org.eclipse.uml2.uml.Property;
<a class="jxr_linenumber" name="L42" href="#L42">42</a>  <strong class="jxr_keyword">import</strong> org.eclipse.uml2.uml.StructuredClassifier;
<a class="jxr_linenumber" name="L43" href="#L43">43</a>  <strong class="jxr_keyword">import</strong> org.eclipse.uml2.uml.TemplateBinding;
<a class="jxr_linenumber" name="L44" href="#L44">44</a>  <strong class="jxr_keyword">import</strong> org.eclipse.uml2.uml.TemplateParameter;
<a class="jxr_linenumber" name="L45" href="#L45">45</a>  <strong class="jxr_keyword">import</strong> org.eclipse.uml2.uml.TemplateParameterSubstitution;
<a class="jxr_linenumber" name="L46" href="#L46">46</a>  <strong class="jxr_keyword">import</strong> org.eclipse.uml2.uml.TemplateSignature;
<a class="jxr_linenumber" name="L47" href="#L47">47</a>  <strong class="jxr_keyword">import</strong> org.eclipse.uml2.uml.TemplateableElement;
<a class="jxr_linenumber" name="L48" href="#L48">48</a>  <strong class="jxr_keyword">import</strong> org.eclipse.uml2.uml.Type;
<a class="jxr_linenumber" name="L49" href="#L49">49</a>  
<a class="jxr_linenumber" name="L50" href="#L50">50</a>  <strong class="jxr_keyword">public</strong> <strong class="jxr_keyword">class</strong> <a href="../../../../../../../org/eclipse/papyrus/designer/components/transformation/templates/TemplateUtils.html">TemplateUtils</a> {
<a class="jxr_linenumber" name="L51" href="#L51">51</a>  
<a class="jxr_linenumber" name="L52" href="#L52">52</a>  	<em class="jxr_javadoccomment">/**</em>
<a class="jxr_linenumber" name="L53" href="#L53">53</a>  <em class="jxr_javadoccomment">	 * Get the template signature of a classifier. If the classifier does not</em>
<a class="jxr_linenumber" name="L54" href="#L54">54</a>  <em class="jxr_javadoccomment">	 * have a signature, examine if the owning class provides one</em>
<a class="jxr_linenumber" name="L55" href="#L55">55</a>  <em class="jxr_javadoccomment">	 *</em>
<a class="jxr_linenumber" name="L56" href="#L56">56</a>  <em class="jxr_javadoccomment">	 * @param template</em>
<a class="jxr_linenumber" name="L57" href="#L57">57</a>  <em class="jxr_javadoccomment">	 *            The potential template</em>
<a class="jxr_linenumber" name="L58" href="#L58">58</a>  <em class="jxr_javadoccomment">	 * @return the signature or null, if none can be found.</em>
<a class="jxr_linenumber" name="L59" href="#L59">59</a>  <em class="jxr_javadoccomment">	 */</em>
<a class="jxr_linenumber" name="L60" href="#L60">60</a>  	<strong class="jxr_keyword">public</strong> <strong class="jxr_keyword">static</strong> TemplateSignature getSignature(TemplateableElement template) {
<a class="jxr_linenumber" name="L61" href="#L61">61</a>  		TemplateSignature signature = getSignatureDirect(template);
<a class="jxr_linenumber" name="L62" href="#L62">62</a>  		<strong class="jxr_keyword">if</strong> (signature != <strong class="jxr_keyword">null</strong>) {
<a class="jxr_linenumber" name="L63" href="#L63">63</a>  			<strong class="jxr_keyword">return</strong> signature;
<a class="jxr_linenumber" name="L64" href="#L64">64</a>  		}
<a class="jxr_linenumber" name="L65" href="#L65">65</a>  
<a class="jxr_linenumber" name="L66" href="#L66">66</a>  		<em class="jxr_comment">// no signature found, try signature of owning classifier (nested class)</em>
<a class="jxr_linenumber" name="L67" href="#L67">67</a>  		<em class="jxr_comment">// or package</em>
<a class="jxr_linenumber" name="L68" href="#L68">68</a>  		Element owner = template.getOwner();
<a class="jxr_linenumber" name="L69" href="#L69">69</a>  		<strong class="jxr_keyword">if</strong> (owner instanceof TemplateableElement) {
<a class="jxr_linenumber" name="L70" href="#L70">70</a>  			<em class="jxr_comment">// owned by a classifier, not a package</em>
<a class="jxr_linenumber" name="L71" href="#L71">71</a>  			<strong class="jxr_keyword">return</strong> getSignature((TemplateableElement) owner);
<a class="jxr_linenumber" name="L72" href="#L72">72</a>  		} <strong class="jxr_keyword">else</strong> {
<a class="jxr_linenumber" name="L73" href="#L73">73</a>  			<strong class="jxr_keyword">return</strong> <strong class="jxr_keyword">null</strong>;
<a class="jxr_linenumber" name="L74" href="#L74">74</a>  		}
<a class="jxr_linenumber" name="L75" href="#L75">75</a>  	}
<a class="jxr_linenumber" name="L76" href="#L76">76</a>  
<a class="jxr_linenumber" name="L77" href="#L77">77</a>  	<strong class="jxr_keyword">public</strong> <strong class="jxr_keyword">static</strong> Element getTemplateOwner(Element ne, TemplateSignature signature) {
<a class="jxr_linenumber" name="L78" href="#L78">78</a>  		<strong class="jxr_keyword">if</strong> ((ne instanceof TemplateableElement) &amp;&amp; getSignatureDirect((TemplateableElement) ne) == signature) {
<a class="jxr_linenumber" name="L79" href="#L79">79</a>  			<strong class="jxr_keyword">return</strong> ne;
<a class="jxr_linenumber" name="L80" href="#L80">80</a>  		}
<a class="jxr_linenumber" name="L81" href="#L81">81</a>  		Element owner = ne.getOwner();
<a class="jxr_linenumber" name="L82" href="#L82">82</a>  		<strong class="jxr_keyword">if</strong> (owner != <strong class="jxr_keyword">null</strong>) {
<a class="jxr_linenumber" name="L83" href="#L83">83</a>  			<strong class="jxr_keyword">return</strong> getTemplateOwner(owner, signature);
<a class="jxr_linenumber" name="L84" href="#L84">84</a>  		}
<a class="jxr_linenumber" name="L85" href="#L85">85</a>  		<strong class="jxr_keyword">return</strong> <strong class="jxr_keyword">null</strong>;
<a class="jxr_linenumber" name="L86" href="#L86">86</a>  	}
<a class="jxr_linenumber" name="L87" href="#L87">87</a>  
<a class="jxr_linenumber" name="L88" href="#L88">88</a>  	<em class="jxr_javadoccomment">/**</em>
<a class="jxr_linenumber" name="L89" href="#L89">89</a>  <em class="jxr_javadoccomment">	 * Get the template signature of a templateable element (typically a package). The class must</em>
<a class="jxr_linenumber" name="L90" href="#L90">90</a>  <em class="jxr_javadoccomment">	 * (1) either own the signature</em>
<a class="jxr_linenumber" name="L91" href="#L91">91</a>  <em class="jxr_javadoccomment">	 * (2) or merge with a package which owns the signature.</em>
<a class="jxr_linenumber" name="L92" href="#L92">92</a>  <em class="jxr_javadoccomment">	 * SW Designer enables the "extension" of existing packages via the package merge mechanism</em>
<a class="jxr_linenumber" name="L93" href="#L93">93</a>  <em class="jxr_javadoccomment">	 *</em>
<a class="jxr_linenumber" name="L94" href="#L94">94</a>  <em class="jxr_javadoccomment">	 * @param template</em>
<a class="jxr_linenumber" name="L95" href="#L95">95</a>  <em class="jxr_javadoccomment">	 *            The potential template</em>
<a class="jxr_linenumber" name="L96" href="#L96">96</a>  <em class="jxr_javadoccomment">	 * @return the signature or null, if none can be found.</em>
<a class="jxr_linenumber" name="L97" href="#L97">97</a>  <em class="jxr_javadoccomment">	 */</em>
<a class="jxr_linenumber" name="L98" href="#L98">98</a>  
<a class="jxr_linenumber" name="L99" href="#L99">99</a>  	<strong class="jxr_keyword">public</strong> <strong class="jxr_keyword">static</strong> TemplateSignature getSignatureDirect(TemplateableElement template) {
<a class="jxr_linenumber" name="L100" href="#L100">100</a> 		<strong class="jxr_keyword">for</strong> (Element element : template.getOwnedElements()) {
<a class="jxr_linenumber" name="L101" href="#L101">101</a> 			<strong class="jxr_keyword">if</strong> (element instanceof TemplateSignature) {
<a class="jxr_linenumber" name="L102" href="#L102">102</a> 				<strong class="jxr_keyword">return</strong> (TemplateSignature) element;
<a class="jxr_linenumber" name="L103" href="#L103">103</a> 			}
<a class="jxr_linenumber" name="L104" href="#L104">104</a> 		}
<a class="jxr_linenumber" name="L105" href="#L105">105</a> 
<a class="jxr_linenumber" name="L106" href="#L106">106</a> 		<em class="jxr_comment">// enable multiple package templates sharing the same signature.</em>
<a class="jxr_linenumber" name="L107" href="#L107">107</a> 		<strong class="jxr_keyword">if</strong> (template instanceof Package) {
<a class="jxr_linenumber" name="L108" href="#L108">108</a> 			Package pkg = (Package) template;
<a class="jxr_linenumber" name="L109" href="#L109">109</a> 			<strong class="jxr_keyword">for</strong> (PackageMerge pkgMerge : pkg.getPackageMerges()) {
<a class="jxr_linenumber" name="L110" href="#L110">110</a> 				Package mergedPkg = pkgMerge.getMergedPackage();
<a class="jxr_linenumber" name="L111" href="#L111">111</a> 				<strong class="jxr_keyword">if</strong> (mergedPkg != pkg) {
<a class="jxr_linenumber" name="L112" href="#L112">112</a> 					<strong class="jxr_keyword">return</strong> getSignature(mergedPkg);
<a class="jxr_linenumber" name="L113" href="#L113">113</a> 				}
<a class="jxr_linenumber" name="L114" href="#L114">114</a> 			}
<a class="jxr_linenumber" name="L115" href="#L115">115</a> 		}
<a class="jxr_linenumber" name="L116" href="#L116">116</a> 		<strong class="jxr_keyword">return</strong> <strong class="jxr_keyword">null</strong>;
<a class="jxr_linenumber" name="L117" href="#L117">117</a> 	}
<a class="jxr_linenumber" name="L118" href="#L118">118</a> 
<a class="jxr_linenumber" name="L119" href="#L119">119</a> 	<em class="jxr_javadoccomment">/**</em>
<a class="jxr_linenumber" name="L120" href="#L120">120</a> <em class="jxr_javadoccomment">	 * Create a template binding by using a single, fixed actual (used within</em>
<a class="jxr_linenumber" name="L121" href="#L121">121</a> <em class="jxr_javadoccomment">	 * SW Designer for the binding of container extensions depending on the component</em>
<a class="jxr_linenumber" name="L122" href="#L122">122</a> <em class="jxr_javadoccomment">	 * executor)</em>
<a class="jxr_linenumber" name="L123" href="#L123">123</a> <em class="jxr_javadoccomment">	 *</em>
<a class="jxr_linenumber" name="L124" href="#L124">124</a> <em class="jxr_javadoccomment">	 * @param model</em>
<a class="jxr_linenumber" name="L125" href="#L125">125</a> <em class="jxr_javadoccomment">	 *            : target model in which to create the bound package</em>
<a class="jxr_linenumber" name="L126" href="#L126">126</a> <em class="jxr_javadoccomment">	 * @param template</em>
<a class="jxr_linenumber" name="L127" href="#L127">127</a> <em class="jxr_javadoccomment">	 * @param fixedActual</em>
<a class="jxr_linenumber" name="L128" href="#L128">128</a> <em class="jxr_javadoccomment">	 * @return</em>
<a class="jxr_linenumber" name="L129" href="#L129">129</a> <em class="jxr_javadoccomment">	 * @throws TransformationException</em>
<a class="jxr_linenumber" name="L130" href="#L130">130</a> <em class="jxr_javadoccomment">	 */</em>
<a class="jxr_linenumber" name="L131" href="#L131">131</a> 	<strong class="jxr_keyword">public</strong> <strong class="jxr_keyword">static</strong> TemplateBinding fixedBinding(Package model, TemplateableElement template, Classifier fixedActual)
<a class="jxr_linenumber" name="L132" href="#L132">132</a> 			<strong class="jxr_keyword">throws</strong> TransformationException {
<a class="jxr_linenumber" name="L133" href="#L133">133</a> 		<em class="jxr_comment">// obtain the signature of an element within a package template.</em>
<a class="jxr_linenumber" name="L134" href="#L134">134</a> 
<a class="jxr_linenumber" name="L135" href="#L135">135</a> 		TemplateSignature signature = getSignature(template);
<a class="jxr_linenumber" name="L136" href="#L136">136</a> 		<strong class="jxr_keyword">if</strong> (signature == <strong class="jxr_keyword">null</strong>) {
<a class="jxr_linenumber" name="L137" href="#L137">137</a> 			<em class="jxr_comment">// not a template, retain original name</em>
<a class="jxr_linenumber" name="L138" href="#L138">138</a> 			Activator.log.info(String.format(
<a class="jxr_linenumber" name="L139" href="#L139">139</a> 					Messages.TemplateUtils_NoTemplateSignature, (template instanceof NamedElement ?
<a class="jxr_linenumber" name="L140" href="#L140">140</a> 							((NamedElement) template).getName() : <span class="jxr_string">"undef"</span>))); <em class="jxr_comment">//$NON-NLS-1$</em>
<a class="jxr_linenumber" name="L141" href="#L141">141</a> 			<strong class="jxr_keyword">return</strong> <strong class="jxr_keyword">null</strong>;
<a class="jxr_linenumber" name="L142" href="#L142">142</a> 		}
<a class="jxr_linenumber" name="L143" href="#L143">143</a> 
<a class="jxr_linenumber" name="L144" href="#L144">144</a> 		EList&lt;Type&gt; actuals = <strong class="jxr_keyword">new</strong> BasicEList&lt;Type&gt;();
<a class="jxr_linenumber" name="L145" href="#L145">145</a> 
<a class="jxr_linenumber" name="L146" href="#L146">146</a> 		Package pkgTemplate = (Package) signature.getOwner();
<a class="jxr_linenumber" name="L147" href="#L147">147</a> 		String name = pkgTemplate.getName();
<a class="jxr_linenumber" name="L148" href="#L148">148</a> 
<a class="jxr_linenumber" name="L149" href="#L149">149</a> 		<em class="jxr_comment">// loop on template parameters;</em>
<a class="jxr_linenumber" name="L150" href="#L150">150</a> 		<em class="jxr_comment">// for (TemplateParameter parameter : signature.getOwnedParameters ()) {</em>
<a class="jxr_linenumber" name="L151" href="#L151">151</a> 		<em class="jxr_comment">// ParameterableElement formal = parameter.getParameteredElement();</em>
<a class="jxr_linenumber" name="L152" href="#L152">152</a> 
<a class="jxr_linenumber" name="L153" href="#L153">153</a> 		<em class="jxr_comment">// now obtain suitable binding for this parameter - look for ports that</em>
<a class="jxr_linenumber" name="L154" href="#L154">154</a> 		<em class="jxr_comment">// are typed with the formal template parameter</em>
<a class="jxr_linenumber" name="L155" href="#L155">155</a> 
<a class="jxr_linenumber" name="L156" href="#L156">156</a> 		actuals.add(fixedActual);
<a class="jxr_linenumber" name="L157" href="#L157">157</a> 		name = name + <span class="jxr_string">"_"</span> + fixedActual.getName(); <em class="jxr_comment">//$NON-NLS-1$</em>
<a class="jxr_linenumber" name="L158" href="#L158">158</a> 		<em class="jxr_comment">// }</em>
<a class="jxr_linenumber" name="L159" href="#L159">159</a> 
<a class="jxr_linenumber" name="L160" href="#L160">160</a> 		<em class="jxr_comment">// the bound package is instantiated in the same model, in which the</em>
<a class="jxr_linenumber" name="L161" href="#L161">161</a> 		<em class="jxr_comment">// composite can be found (avoid modifying an imported model).</em>
<a class="jxr_linenumber" name="L162" href="#L162">162</a> 		<em class="jxr_comment">// todo: root model as an additional parameter?</em>
<a class="jxr_linenumber" name="L163" href="#L163">163</a> 		Namespace owner = (Namespace) pkgTemplate.getOwner();
<a class="jxr_linenumber" name="L164" href="#L164">164</a> 		owner = CreationUtils.getAndCreate(model, owner.allNamespaces());
<a class="jxr_linenumber" name="L165" href="#L165">165</a> 
<a class="jxr_linenumber" name="L166" href="#L166">166</a> 		Package boundPackage = (Package) owner.getMember(name);
<a class="jxr_linenumber" name="L167" href="#L167">167</a> 		<strong class="jxr_keyword">if</strong> (boundPackage == <strong class="jxr_keyword">null</strong>) {
<a class="jxr_linenumber" name="L168" href="#L168">168</a> 			<em class="jxr_comment">// class does not exist yet, needs to be created.</em>
<a class="jxr_linenumber" name="L169" href="#L169">169</a> 			boundPackage = ((Package) owner).createNestedPackage(name);
<a class="jxr_linenumber" name="L170" href="#L170">170</a> 
<a class="jxr_linenumber" name="L171" href="#L171">171</a> 			Activator.log.info(String.format(
<a class="jxr_linenumber" name="L172" href="#L172">172</a> 					Messages.TemplateUtils_InfoCreateBoundPackage, name, owner.getName()));
<a class="jxr_linenumber" name="L173" href="#L173">173</a> 		}
<a class="jxr_linenumber" name="L174" href="#L174">174</a> 
<a class="jxr_linenumber" name="L175" href="#L175">175</a> 		TemplateBinding binding = boundPackage.getTemplateBinding(signature);
<a class="jxr_linenumber" name="L176" href="#L176">176</a> 		<strong class="jxr_keyword">if</strong> (binding == <strong class="jxr_keyword">null</strong>) {
<a class="jxr_linenumber" name="L177" href="#L177">177</a> 			<em class="jxr_comment">// binding is not existing yet (should normally only happen, if the class has</em>
<a class="jxr_linenumber" name="L178" href="#L178">178</a> 			<em class="jxr_comment">// just been created - but it's better to re-check, even if the bound package</em>
<a class="jxr_linenumber" name="L179" href="#L179">179</a> 			<em class="jxr_comment">// was already there)</em>
<a class="jxr_linenumber" name="L180" href="#L180">180</a> 			binding = boundPackage.createTemplateBinding(signature);
<a class="jxr_linenumber" name="L181" href="#L181">181</a> 
<a class="jxr_linenumber" name="L182" href="#L182">182</a> 			Iterator&lt;Type&gt; actualsIter = actuals.iterator();
<a class="jxr_linenumber" name="L183" href="#L183">183</a> 
<a class="jxr_linenumber" name="L184" href="#L184">184</a> 			<em class="jxr_comment">// loop on template parameters;</em>
<a class="jxr_linenumber" name="L185" href="#L185">185</a> 			<strong class="jxr_keyword">for</strong> (TemplateParameter parameter : signature.getOwnedParameters()) {
<a class="jxr_linenumber" name="L186" href="#L186">186</a> 
<a class="jxr_linenumber" name="L187" href="#L187">187</a> 				TemplateParameterSubstitution substitution =
<a class="jxr_linenumber" name="L188" href="#L188">188</a> 						binding.createParameterSubstitution();
<a class="jxr_linenumber" name="L189" href="#L189">189</a> 				substitution.setFormal(parameter);
<a class="jxr_linenumber" name="L190" href="#L190">190</a> 
<a class="jxr_linenumber" name="L191" href="#L191">191</a> 				<em class="jxr_comment">// now obtain suitable binding for this parameter - look for</em>
<a class="jxr_linenumber" name="L192" href="#L192">192</a> 				<em class="jxr_comment">// ports that are typed with</em>
<a class="jxr_linenumber" name="L193" href="#L193">193</a> 				<em class="jxr_comment">// the formal template parameter</em>
<a class="jxr_linenumber" name="L194" href="#L194">194</a> 				Type actual = actualsIter.next();
<a class="jxr_linenumber" name="L195" href="#L195">195</a> 				substitution.setActual(actual);
<a class="jxr_linenumber" name="L196" href="#L196">196</a> 			}
<a class="jxr_linenumber" name="L197" href="#L197">197</a> 		}
<a class="jxr_linenumber" name="L198" href="#L198">198</a> 		<strong class="jxr_keyword">return</strong> binding;
<a class="jxr_linenumber" name="L199" href="#L199">199</a> 	}
<a class="jxr_linenumber" name="L200" href="#L200">200</a> 
<a class="jxr_linenumber" name="L201" href="#L201">201</a> 	<em class="jxr_javadoccomment">/**</em>
<a class="jxr_linenumber" name="L202" href="#L202">202</a> <em class="jxr_javadoccomment">	 * create a "sub" binding in which the first parameter of type Cl is assumed</em>
<a class="jxr_linenumber" name="L203" href="#L203">203</a> <em class="jxr_javadoccomment">	 * to bind the sub-signature TODO: compared type and name of parameters in</em>
<a class="jxr_linenumber" name="L204" href="#L204">204</a> <em class="jxr_javadoccomment">	 * two signatures TODO: support more than one template parameter</em>
<a class="jxr_linenumber" name="L205" href="#L205">205</a> <em class="jxr_javadoccomment">	 *</em>
<a class="jxr_linenumber" name="L206" href="#L206">206</a> <em class="jxr_javadoccomment">	 * @param model</em>
<a class="jxr_linenumber" name="L207" href="#L207">207</a> <em class="jxr_javadoccomment">	 * @param te</em>
<a class="jxr_linenumber" name="L208" href="#L208">208</a> <em class="jxr_javadoccomment">	 * @param existingBinding</em>
<a class="jxr_linenumber" name="L209" href="#L209">209</a> <em class="jxr_javadoccomment">	 * @return</em>
<a class="jxr_linenumber" name="L210" href="#L210">210</a> <em class="jxr_javadoccomment">	 * @throws TransformationException</em>
<a class="jxr_linenumber" name="L211" href="#L211">211</a> <em class="jxr_javadoccomment">	 */</em>
<a class="jxr_linenumber" name="L212" href="#L212">212</a> 	<strong class="jxr_keyword">public</strong> <strong class="jxr_keyword">static</strong> TemplateBinding getSubBinding(Package model,
<a class="jxr_linenumber" name="L213" href="#L213">213</a> 			TemplateableElement te, TemplateBinding existingBinding)
<a class="jxr_linenumber" name="L214" href="#L214">214</a> 			<strong class="jxr_keyword">throws</strong> TransformationException {
<a class="jxr_linenumber" name="L215" href="#L215">215</a> 
<a class="jxr_linenumber" name="L216" href="#L216">216</a> 		<strong class="jxr_keyword">for</strong> (TemplateParameterSubstitution tps : existingBinding.getParameterSubstitutions()) {
<a class="jxr_linenumber" name="L217" href="#L217">217</a> 			ParameterableElement pe = tps.getActual();
<a class="jxr_linenumber" name="L218" href="#L218">218</a> 			<strong class="jxr_keyword">if</strong> (pe instanceof Classifier) {
<a class="jxr_linenumber" name="L219" href="#L219">219</a> 				<strong class="jxr_keyword">return</strong> fixedBinding(model, te, (Classifier) pe);
<a class="jxr_linenumber" name="L220" href="#L220">220</a> 			}
<a class="jxr_linenumber" name="L221" href="#L221">221</a> 		}
<a class="jxr_linenumber" name="L222" href="#L222">222</a> 		<strong class="jxr_keyword">return</strong> <strong class="jxr_keyword">null</strong>;
<a class="jxr_linenumber" name="L223" href="#L223">223</a> 	}
<a class="jxr_linenumber" name="L224" href="#L224">224</a> 
<a class="jxr_linenumber" name="L225" href="#L225">225</a> 	<em class="jxr_javadoccomment">/**</em>
<a class="jxr_linenumber" name="L226" href="#L226">226</a> <em class="jxr_javadoccomment">	 * Adapt the actuals within the binding (which correspond either to an</em>
<a class="jxr_linenumber" name="L227" href="#L227">227</a> <em class="jxr_javadoccomment">	 * element of the source model or an imported element) to the target model.</em>
<a class="jxr_linenumber" name="L228" href="#L228">228</a> <em class="jxr_javadoccomment">	 *</em>
<a class="jxr_linenumber" name="L229" href="#L229">229</a> <em class="jxr_javadoccomment">	 * @param sat</em>
<a class="jxr_linenumber" name="L230" href="#L230">230</a> <em class="jxr_javadoccomment">	 * @param binding</em>
<a class="jxr_linenumber" name="L231" href="#L231">231</a> <em class="jxr_javadoccomment">	 */</em>
<a class="jxr_linenumber" name="L232" href="#L232">232</a> 	<strong class="jxr_keyword">public</strong> <strong class="jxr_keyword">static</strong> <strong class="jxr_keyword">void</strong> adaptActualsToTargetModel(LazyCopier copy, TemplateBinding binding) {
<a class="jxr_linenumber" name="L233" href="#L233">233</a> 		<strong class="jxr_keyword">for</strong> (TemplateParameterSubstitution substitution : binding.getParameterSubstitutions()) {
<a class="jxr_linenumber" name="L234" href="#L234">234</a> 			substitution.setActual(copy.getCopy(substitution.getActual()));
<a class="jxr_linenumber" name="L235" href="#L235">235</a> 		}
<a class="jxr_linenumber" name="L236" href="#L236">236</a> 	}
<a class="jxr_linenumber" name="L237" href="#L237">237</a> 
<a class="jxr_linenumber" name="L238" href="#L238">238</a> 	<em class="jxr_javadoccomment">/**</em>
<a class="jxr_linenumber" name="L239" href="#L239">239</a> <em class="jxr_javadoccomment">	 * Return the actual for a potential formal parameter within a</em>
<a class="jxr_linenumber" name="L240" href="#L240">240</a> <em class="jxr_javadoccomment">	 * templateBinding (move to TemplateUtils?)</em>
<a class="jxr_linenumber" name="L241" href="#L241">241</a> <em class="jxr_javadoccomment">	 *</em>
<a class="jxr_linenumber" name="L242" href="#L242">242</a> <em class="jxr_javadoccomment">	 * @param binding</em>
<a class="jxr_linenumber" name="L243" href="#L243">243</a> <em class="jxr_javadoccomment">	 *            a template binding</em>
<a class="jxr_linenumber" name="L244" href="#L244">244</a> <em class="jxr_javadoccomment">	 * @param formal</em>
<a class="jxr_linenumber" name="L245" href="#L245">245</a> <em class="jxr_javadoccomment">	 *            a potential formal parameter, i.e. a parameter for which we</em>
<a class="jxr_linenumber" name="L246" href="#L246">246</a> <em class="jxr_javadoccomment">	 *            check, if it really corresponds to a formal parameter within</em>
<a class="jxr_linenumber" name="L247" href="#L247">247</a> <em class="jxr_javadoccomment">	 *            the template binding.</em>
<a class="jxr_linenumber" name="L248" href="#L248">248</a> <em class="jxr_javadoccomment">	 * @return the actual parameter that is associated with the potential formal</em>
<a class="jxr_linenumber" name="L249" href="#L249">249</a> <em class="jxr_javadoccomment">	 *         parameter, or null if the 2nd parameter does not correspond to a</em>
<a class="jxr_linenumber" name="L250" href="#L250">250</a> <em class="jxr_javadoccomment">	 *         formal parameter of the binding.</em>
<a class="jxr_linenumber" name="L251" href="#L251">251</a> <em class="jxr_javadoccomment">	 */</em>
<a class="jxr_linenumber" name="L252" href="#L252">252</a> 	<strong class="jxr_keyword">public</strong> <strong class="jxr_keyword">static</strong> Classifier getActualFromBinding(TemplateBinding binding, Type formal) {
<a class="jxr_linenumber" name="L253" href="#L253">253</a> 		<strong class="jxr_keyword">for</strong> (TemplateParameterSubstitution substitution : binding.getParameterSubstitutions()) {
<a class="jxr_linenumber" name="L254" href="#L254">254</a> 			ParameterableElement pe = substitution.getFormal().getParameteredElement();
<a class="jxr_linenumber" name="L255" href="#L255">255</a> 			<strong class="jxr_keyword">if</strong> (pe == formal) {
<a class="jxr_linenumber" name="L256" href="#L256">256</a> 				Activator.log.info(String.format(
<a class="jxr_linenumber" name="L257" href="#L257">257</a> 						Messages.TemplateUtils_InfoGetActualFrom, pe));
<a class="jxr_linenumber" name="L258" href="#L258">258</a> 				<strong class="jxr_keyword">return</strong> (Classifier) substitution.getActual();
<a class="jxr_linenumber" name="L259" href="#L259">259</a> 			}
<a class="jxr_linenumber" name="L260" href="#L260">260</a> 		}
<a class="jxr_linenumber" name="L261" href="#L261">261</a> 		<strong class="jxr_keyword">return</strong> <strong class="jxr_keyword">null</strong>;
<a class="jxr_linenumber" name="L262" href="#L262">262</a> 	}
<a class="jxr_linenumber" name="L263" href="#L263">263</a> 
<a class="jxr_linenumber" name="L264" href="#L264">264</a> 	<strong class="jxr_keyword">public</strong> <strong class="jxr_keyword">static</strong> Classifier getActualFromBinding(TemplateBinding binding, String formalName) {
<a class="jxr_linenumber" name="L265" href="#L265">265</a> 		<strong class="jxr_keyword">for</strong> (TemplateParameterSubstitution substitution : binding.getParameterSubstitutions()) {
<a class="jxr_linenumber" name="L266" href="#L266">266</a> 			ParameterableElement pe = substitution.getFormal().getParameteredElement();
<a class="jxr_linenumber" name="L267" href="#L267">267</a> 			Activator.log.info(String.format(
<a class="jxr_linenumber" name="L268" href="#L268">268</a> 					Messages.TemplateUtils_InfoGetActualFrom, pe));
<a class="jxr_linenumber" name="L269" href="#L269">269</a> 			<strong class="jxr_keyword">if</strong> ((pe instanceof NamedElement)
<a class="jxr_linenumber" name="L270" href="#L270">270</a> 					&amp;&amp; ((NamedElement) pe).getName().equals(formalName)) {
<a class="jxr_linenumber" name="L271" href="#L271">271</a> 				<strong class="jxr_keyword">return</strong> (Classifier) substitution.getActual();
<a class="jxr_linenumber" name="L272" href="#L272">272</a> 			}
<a class="jxr_linenumber" name="L273" href="#L273">273</a> 		}
<a class="jxr_linenumber" name="L274" href="#L274">274</a> 		<strong class="jxr_keyword">return</strong> <strong class="jxr_keyword">null</strong>;
<a class="jxr_linenumber" name="L275" href="#L275">275</a> 	}
<a class="jxr_linenumber" name="L276" href="#L276">276</a> 
<a class="jxr_linenumber" name="L277" href="#L277">277</a> 	<em class="jxr_javadoccomment">/**</em>
<a class="jxr_linenumber" name="L278" href="#L278">278</a> <em class="jxr_javadoccomment">	 * Get the first actual from the binding.</em>
<a class="jxr_linenumber" name="L279" href="#L279">279</a> <em class="jxr_javadoccomment">	 *</em>
<a class="jxr_linenumber" name="L280" href="#L280">280</a> <em class="jxr_javadoccomment">	 * @param binding</em>
<a class="jxr_linenumber" name="L281" href="#L281">281</a> <em class="jxr_javadoccomment">	 *            the template binding</em>
<a class="jxr_linenumber" name="L282" href="#L282">282</a> <em class="jxr_javadoccomment">	 * @return the first actual.</em>
<a class="jxr_linenumber" name="L283" href="#L283">283</a> <em class="jxr_javadoccomment">	 */</em>
<a class="jxr_linenumber" name="L284" href="#L284">284</a> 	<strong class="jxr_keyword">public</strong> <strong class="jxr_keyword">static</strong> Classifier getFirstActualFromBinding(TemplateBinding binding) {
<a class="jxr_linenumber" name="L285" href="#L285">285</a> 		<strong class="jxr_keyword">for</strong> (TemplateParameterSubstitution substitution : binding.getParameterSubstitutions()) {
<a class="jxr_linenumber" name="L286" href="#L286">286</a> 			ParameterableElement pe = substitution.getFormal().getParameteredElement();
<a class="jxr_linenumber" name="L287" href="#L287">287</a> 			Activator.log.info(String.format(
<a class="jxr_linenumber" name="L288" href="#L288">288</a> 					Messages.TemplateUtils_InfoGetActualFrom, pe));
<a class="jxr_linenumber" name="L289" href="#L289">289</a> 			<strong class="jxr_keyword">return</strong> (Classifier) substitution.getActual();
<a class="jxr_linenumber" name="L290" href="#L290">290</a> 		}
<a class="jxr_linenumber" name="L291" href="#L291">291</a> 		<strong class="jxr_keyword">return</strong> <strong class="jxr_keyword">null</strong>;
<a class="jxr_linenumber" name="L292" href="#L292">292</a> 	}
<a class="jxr_linenumber" name="L293" href="#L293">293</a> 
<a class="jxr_linenumber" name="L294" href="#L294">294</a> 	<em class="jxr_javadoccomment">/**</em>
<a class="jxr_linenumber" name="L295" href="#L295">295</a> <em class="jxr_javadoccomment">	 * Return a sequence of namespaces for a given element, starting from the "bottom"</em>
<a class="jxr_linenumber" name="L296" href="#L296">296</a> <em class="jxr_javadoccomment">	 * one, i.e. the one in which the element is contained. It will end before the</em>
<a class="jxr_linenumber" name="L297" href="#L297">297</a> <em class="jxr_javadoccomment">	 * searchNS namespace is reached. Returns null, if the element is not contained</em>
<a class="jxr_linenumber" name="L298" href="#L298">298</a> <em class="jxr_javadoccomment">	 * within the search namespace.</em>
<a class="jxr_linenumber" name="L299" href="#L299">299</a> <em class="jxr_javadoccomment">	 * This function will put a merged package into the path (instead of the owner), enabling</em>
<a class="jxr_linenumber" name="L300" href="#L300">300</a> <em class="jxr_javadoccomment">	 * the extension of existing packages.</em>
<a class="jxr_linenumber" name="L301" href="#L301">301</a> <em class="jxr_javadoccomment">	 *</em>
<a class="jxr_linenumber" name="L302" href="#L302">302</a> <em class="jxr_javadoccomment">	 * @param element</em>
<a class="jxr_linenumber" name="L303" href="#L303">303</a> <em class="jxr_javadoccomment">	 * @param searchNS</em>
<a class="jxr_linenumber" name="L304" href="#L304">304</a> <em class="jxr_javadoccomment">	 * @return</em>
<a class="jxr_linenumber" name="L305" href="#L305">305</a> <em class="jxr_javadoccomment">	 */</em>
<a class="jxr_linenumber" name="L306" href="#L306">306</a> 	<strong class="jxr_keyword">public</strong> <strong class="jxr_keyword">static</strong> EList&lt;Namespace&gt; relativePathWithMerge(Element element, Namespace searchNS) {
<a class="jxr_linenumber" name="L307" href="#L307">307</a> 		EList&lt;Namespace&gt; pathList = <strong class="jxr_keyword">new</strong> BasicEList&lt;Namespace&gt;();
<a class="jxr_linenumber" name="L308" href="#L308">308</a> 		Element owner = element.getOwner();
<a class="jxr_linenumber" name="L309" href="#L309">309</a> 		<strong class="jxr_keyword">if</strong> (!(owner instanceof Namespace)) {
<a class="jxr_linenumber" name="L310" href="#L310">310</a> 			<em class="jxr_comment">// happens, if element is contained in a template signature</em>
<a class="jxr_linenumber" name="L311" href="#L311">311</a> 			<strong class="jxr_keyword">return</strong> <strong class="jxr_keyword">null</strong>;
<a class="jxr_linenumber" name="L312" href="#L312">312</a> 		}
<a class="jxr_linenumber" name="L313" href="#L313">313</a> 		Namespace ns = (Namespace) owner;
<a class="jxr_linenumber" name="L314" href="#L314">314</a> 		<strong class="jxr_keyword">while</strong> (ns != <strong class="jxr_keyword">null</strong>) {
<a class="jxr_linenumber" name="L315" href="#L315">315</a> 			<strong class="jxr_keyword">if</strong> (ns == searchNS) {
<a class="jxr_linenumber" name="L316" href="#L316">316</a> 				<strong class="jxr_keyword">return</strong> pathList;
<a class="jxr_linenumber" name="L317" href="#L317">317</a> 			}
<a class="jxr_linenumber" name="L318" href="#L318">318</a> 			pathList.add(ns);
<a class="jxr_linenumber" name="L319" href="#L319">319</a> 
<a class="jxr_linenumber" name="L320" href="#L320">320</a> 			<strong class="jxr_keyword">if</strong> (ns instanceof Package) {
<a class="jxr_linenumber" name="L321" href="#L321">321</a> 				Package pkg = (Package) ns;
<a class="jxr_linenumber" name="L322" href="#L322">322</a> 				Iterator&lt;PackageMerge&gt; pkgMerges = pkg.getPackageMerges().iterator();
<a class="jxr_linenumber" name="L323" href="#L323">323</a> 				<em class="jxr_comment">// if package merge exists, get first merged package and add it to path</em>
<a class="jxr_linenumber" name="L324" href="#L324">324</a> 				<strong class="jxr_keyword">if</strong> (pkgMerges.hasNext()) {
<a class="jxr_linenumber" name="L325" href="#L325">325</a> 					PackageMerge pkgImport = pkgMerges.next();
<a class="jxr_linenumber" name="L326" href="#L326">326</a> 					ns = pkgImport.getMergedPackage();
<a class="jxr_linenumber" name="L327" href="#L327">327</a> 					<strong class="jxr_keyword">continue</strong>;
<a class="jxr_linenumber" name="L328" href="#L328">328</a> 				}
<a class="jxr_linenumber" name="L329" href="#L329">329</a> 			}
<a class="jxr_linenumber" name="L330" href="#L330">330</a> 
<a class="jxr_linenumber" name="L331" href="#L331">331</a> 			ns = (Namespace) ns.getOwner();
<a class="jxr_linenumber" name="L332" href="#L332">332</a> 		}
<a class="jxr_linenumber" name="L333" href="#L333">333</a> 		<strong class="jxr_keyword">return</strong> <strong class="jxr_keyword">null</strong>;
<a class="jxr_linenumber" name="L334" href="#L334">334</a> 	}
<a class="jxr_linenumber" name="L335" href="#L335">335</a> 
<a class="jxr_linenumber" name="L336" href="#L336">336</a> 	<em class="jxr_javadoccomment">/**</em>
<a class="jxr_linenumber" name="L337" href="#L337">337</a> <em class="jxr_javadoccomment">	 * Re-target connectors after a part has changed its type from template to an instantiation</em>
<a class="jxr_linenumber" name="L338" href="#L338">338</a> <em class="jxr_javadoccomment">	 * of this template. In this case, the roles of the connector ends still reference the port</em>
<a class="jxr_linenumber" name="L339" href="#L339">339</a> <em class="jxr_javadoccomment">	 * of the template instead of the bound template binding.</em>
<a class="jxr_linenumber" name="L340" href="#L340">340</a> <em class="jxr_javadoccomment">	 * The new roles are assigned based on an equal name, assuming that template instantiation</em>
<a class="jxr_linenumber" name="L341" href="#L341">341</a> <em class="jxr_javadoccomment">	 * does not change the name of the ports.</em>
<a class="jxr_linenumber" name="L342" href="#L342">342</a> <em class="jxr_javadoccomment">	 *</em>
<a class="jxr_linenumber" name="L343" href="#L343">343</a> <em class="jxr_javadoccomment">	 * @param composite</em>
<a class="jxr_linenumber" name="L344" href="#L344">344</a> <em class="jxr_javadoccomment">	 *            a composite containing connectors</em>
<a class="jxr_linenumber" name="L345" href="#L345">345</a> <em class="jxr_javadoccomment">	 * @param part</em>
<a class="jxr_linenumber" name="L346" href="#L346">346</a> <em class="jxr_javadoccomment">	 *            a part within the composite whose type has changed.</em>
<a class="jxr_linenumber" name="L347" href="#L347">347</a> <em class="jxr_javadoccomment">	 */</em>
<a class="jxr_linenumber" name="L348" href="#L348">348</a> 	<strong class="jxr_keyword">public</strong> <strong class="jxr_keyword">static</strong> <strong class="jxr_keyword">void</strong> retargetConnectors(StructuredClassifier composite, Property part) {
<a class="jxr_linenumber" name="L349" href="#L349">349</a> 		Type partType = part.getType();
<a class="jxr_linenumber" name="L350" href="#L350">350</a> 		<strong class="jxr_keyword">if</strong> (partType instanceof EncapsulatedClassifier) {
<a class="jxr_linenumber" name="L351" href="#L351">351</a> 			EncapsulatedClassifier partTypeEC = (EncapsulatedClassifier) partType;
<a class="jxr_linenumber" name="L352" href="#L352">352</a> 			<strong class="jxr_keyword">for</strong> (Connector connector : composite.getOwnedConnectors()) {
<a class="jxr_linenumber" name="L353" href="#L353">353</a> 				<strong class="jxr_keyword">if</strong> (ConnectorUtil.connectsPart(connector, part)) {
<a class="jxr_linenumber" name="L354" href="#L354">354</a> 					<em class="jxr_comment">// the connector end targets a port of a part or the composite (in case of delegation)</em>
<a class="jxr_linenumber" name="L355" href="#L355">355</a> 					ConnectorEnd connEnd = ConnectorUtil.connEndForPart(connector, part);
<a class="jxr_linenumber" name="L356" href="#L356">356</a> 					<em class="jxr_comment">// redirect role, if pointing to port</em>
<a class="jxr_linenumber" name="L357" href="#L357">357</a> 					<strong class="jxr_keyword">if</strong> (connEnd.getRole() instanceof Port) {
<a class="jxr_linenumber" name="L358" href="#L358">358</a> 						Port connectedTemplatePort = (Port) connEnd.getRole();
<a class="jxr_linenumber" name="L359" href="#L359">359</a> 						Port connectedBoundPort = (Port) ElementUtils.getNamedElementFromList(
<a class="jxr_linenumber" name="L360" href="#L360">360</a> 								PortUtils.getAllPorts(partTypeEC), connectedTemplatePort.getName());
<a class="jxr_linenumber" name="L361" href="#L361">361</a> 						connEnd.setRole(connectedBoundPort);
<a class="jxr_linenumber" name="L362" href="#L362">362</a> 					}
<a class="jxr_linenumber" name="L363" href="#L363">363</a> 				}
<a class="jxr_linenumber" name="L364" href="#L364">364</a> 			}
<a class="jxr_linenumber" name="L365" href="#L365">365</a> 		}
<a class="jxr_linenumber" name="L366" href="#L366">366</a> 	}
<a class="jxr_linenumber" name="L367" href="#L367">367</a> 
<a class="jxr_linenumber" name="L368" href="#L368">368</a> 	<em class="jxr_javadoccomment">/**</em>
<a class="jxr_linenumber" name="L369" href="#L369">369</a> <em class="jxr_javadoccomment">	 * Re-target connectors after an unknown number of parts have changed their type from template</em>
<a class="jxr_linenumber" name="L370" href="#L370">370</a> <em class="jxr_javadoccomment">	 * to an instantiation of this template. In this case, the roles of the connector ends still</em>
<a class="jxr_linenumber" name="L371" href="#L371">371</a> <em class="jxr_javadoccomment">	 * reference the port of the template instead of the bound template binding.</em>
<a class="jxr_linenumber" name="L372" href="#L372">372</a> <em class="jxr_javadoccomment">	 * The new roles are assigned based on an equal name, assuming that template instantiation</em>
<a class="jxr_linenumber" name="L373" href="#L373">373</a> <em class="jxr_javadoccomment">	 * does not change the name of the ports.</em>
<a class="jxr_linenumber" name="L374" href="#L374">374</a> <em class="jxr_javadoccomment">	 *</em>
<a class="jxr_linenumber" name="L375" href="#L375">375</a> <em class="jxr_javadoccomment">	 * @param composite</em>
<a class="jxr_linenumber" name="L376" href="#L376">376</a> <em class="jxr_javadoccomment">	 *            a composite containing connectors</em>
<a class="jxr_linenumber" name="L377" href="#L377">377</a> <em class="jxr_javadoccomment">	 */</em>
<a class="jxr_linenumber" name="L378" href="#L378">378</a> 	<strong class="jxr_keyword">public</strong> <strong class="jxr_keyword">static</strong> <strong class="jxr_keyword">void</strong> retargetConnectors(StructuredClassifier composite) {
<a class="jxr_linenumber" name="L379" href="#L379">379</a> 		<strong class="jxr_keyword">for</strong> (Connector connector : composite.getOwnedConnectors()) {
<a class="jxr_linenumber" name="L380" href="#L380">380</a> 			<em class="jxr_comment">// the connector end targets a port of a part or the composite (in case of delegation)</em>
<a class="jxr_linenumber" name="L381" href="#L381">381</a> 			<strong class="jxr_keyword">for</strong> (ConnectorEnd connEnd : connector.getEnds()) {
<a class="jxr_linenumber" name="L382" href="#L382">382</a> 				Property part = connEnd.getPartWithPort();
<a class="jxr_linenumber" name="L383" href="#L383">383</a> 				<strong class="jxr_keyword">if</strong> ((part != <strong class="jxr_keyword">null</strong>) &amp;&amp; (part.getType() instanceof EncapsulatedClassifier)) {
<a class="jxr_linenumber" name="L384" href="#L384">384</a> 					EncapsulatedClassifier partTypeEC = (EncapsulatedClassifier) part.getType();
<a class="jxr_linenumber" name="L385" href="#L385">385</a> 					ConnectableElement role = connEnd.getRole();
<a class="jxr_linenumber" name="L386" href="#L386">386</a> 					EList&lt;Port&gt; ports = PortUtils.getAllPorts(partTypeEC);
<a class="jxr_linenumber" name="L387" href="#L387">387</a> 					<strong class="jxr_keyword">if</strong> ((role instanceof Port) &amp;&amp; !ports.contains(role)) {
<a class="jxr_linenumber" name="L388" href="#L388">388</a> 						<em class="jxr_comment">// role is not in list of ports</em>
<a class="jxr_linenumber" name="L389" href="#L389">389</a> 						Port connectedBoundPort = (Port) ElementUtils.getNamedElementFromList(ports, role.getName());
<a class="jxr_linenumber" name="L390" href="#L390">390</a> 						connEnd.setRole(connectedBoundPort);
<a class="jxr_linenumber" name="L391" href="#L391">391</a> 					}
<a class="jxr_linenumber" name="L392" href="#L392">392</a> 				}
<a class="jxr_linenumber" name="L393" href="#L393">393</a> 			}
<a class="jxr_linenumber" name="L394" href="#L394">394</a> 		}
<a class="jxr_linenumber" name="L395" href="#L395">395</a> 	}
<a class="jxr_linenumber" name="L396" href="#L396">396</a> }
</pre>
<hr/>
<div id="footer">Copyright &#169; 2016&#x2013;2017 <a href="https://www.eclipse.org/">Eclipse foundation</a>. All rights reserved.</div>
</body>
</html>
